
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>2014-07-09 Java Web的学习(5)-----会话管理(Cookie和Session) / 憋错料</title>

    <meta name="description" content="2014-07-09 Java Web的学习(5)-----会话管理(Cookie和Session) 1.什么是会话 会话,牛津词典对其的解释是进行某活动连续的一段时间.从不同的层面看待会话,它有着类似但不全然相同的含义.比如,在web应用的用户看来,他打开浏览器访问一个电子商务网站,登录.并完成购物直到关闭浏览器,这是一个会话.而在web应用的开发者开来,用户登录时我需要创建一个数据结构以存储用户的登录信息,这个结构也叫做会话.因此在谈论会话的时候要注意上下文环境.而本文谈论的是一种基于HTTP协议的用以增强web应用能力的机制或者说一种方案,它不是单指某种特定的动态页面技术,而这种能力就是保">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">2014-07-09 Java Web的学习(5)-----会话管理(Cookie和Session)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>1.什么是会话</h2>
<p>会话，牛津词典对其的解释是进行某活动连续的一段时间。从不同的层面看待会话，它有着类似但不全然相同的含义。比如，在web应用的用户看来，他打开浏览器访问一个电子商务网站，登录、并完成购物直到关闭浏览器，这是一个会话。而在web应用的开发者开来，用户登录时我需要创建一个数据结构以存储用户的登录信息，这个结构也叫做会话。因此在谈论会话的时候要注意上下文环境。而本文谈论的是一种基于HTTP协议的用以增强web应用能力的机制或者说一种方案，它不是单指某种特定的动态页面技术，而这种能力就是保持状态，也可以称作保持会话。</p>
<h2>2.为什么需要会话</h2>
<p>谈及会话一般是在web应用的背景之下，我们知道web应用是基于HTTP协议的，而HTTP协议恰恰是一种无状态协议。也就是说，用户从A页面跳转到B页面会重新发送一次HTTP请求，而服务端在返回响应的时候是无法获知该用户在请求B页面之前做了什么的。</p>
<p>对于HTTP的无状态性的原因，相关RFC里并没有解释，但联系到HTTP的历史以及应用场景，我们可以推测出一些理由：</p>
<ul>
<li>设计HTTP最初的目的是为了提供一种发布和接收HTML页面的方法。那个时候没有动态页面技术，只有纯粹的静态HTML页面，因此根本不需要协议能保持状态；</li>
<li>用户在收到响应时，往往要花一些时间来阅读页面，因此如果保持客户端和服务端之间的连接，那么这个连接在大多数的时间里都将是空闲的，这是一种资源的无端浪费。所以HTTP原始的设计是默认短连接，即客户端和服务端完成一次请求和响应之后就断开TCP连接，服务器因此无法预知客户端的下一个动作，它甚至都不知道这个用户会不会再次访问，因此让HTTP协议来维护用户的访问状态也全然没有必要；</li>
<li>将一部分复杂性转嫁到以HTTP协议为基础的技术之上可以使得HTTP在协议这个层面上显得相对简单，而这种简单也赋予了HTTP更强的扩展能力。事实上，会话技术从本质上来讲也是对HTTP协议的一种扩展。</li>
</ul>
<p>总而言之，HTTP的无状态是由其历史使命而决定的。但随着网络技术的蓬勃发展，人们再也不满足于死板乏味的静态HTML，他们希望web应用能动起来，于是客户端出现了脚本和DOM技术，HTML里增加了表单，而服务端出现了CGI等等动态技术。</p>
<p>而正是这种web动态化的需求，给HTTP协议提出了一个难题：一个无状态的协议怎样才能关联两次连续的请求呢？也就是说无状态的协议怎样才能满足有状态的需求呢？</p>
<p>此时有状态是必然趋势而协议的无状态性也是木已成舟，因此我们需要一些方案来解决这个矛盾，来保持HTTP连接状态，于是出现了cookie和session技术。</p>
<p>对于此部分内容，读者或许会有一些疑问，笔者在此先谈两点：</p>
<ul>
<li>无状态性和长连接</li>
</ul>
<p>可能有人会问，现在被广泛使用的HTTP1.1默认使用长连接，它还是无状态的吗？</p>
<p>连接方式和有无状态是完全没有关系的两回事。因为状态从某种意义上来讲就是数据，而连接方式只是决定了数据的传输方式，而不能决定数据。长连接是随着计算机性能的提高和网络环境的改善所采取的一种合理的性能上的优化，一般情况下，web服务器会对长连接的数量进行限制，以免资源的过度消耗。</p>
<ul>
<li>无状态性和会话</li>
</ul>
<p>会话是有状态的，而HTTP协议是无状态的，二者是否矛盾呢？</p>
<p>会话和HTTP协议属于不同层面的事物，后者属于ISO七层模型的最高层应用层，前者不属于后者，前者是具体的动态页面技术来实现的，但同时它又是基于后者的。在下文中笔者会分析Servlet/Jsp技术中的会话机制，这会使你对此有更深刻的理解。</p>
<h2>3.Cookie 和 Session</h2>
<p>上面提到解决HTTP协议自身无状态的方式有Cookie和Session。二者都能记录状态，前者是将状态数据保存在客户端，后者则保存在服务端.<strong>它们有各自的优点也有各自的缺陷。然而具有讽刺意味的是它们优点和它们的使用场景又是矛盾的，例如使用 Cookie 来传递信息时，随着 Cookie 个数的增多和访问量的增加，它占用的网络带宽也很大，试想假如 Cookie 占用 200 个字节，如果一天的 PV 有几亿的时候，它要占用多少带宽。所以大访问量的时候希望用 Session，但是 Session 的致命弱点是不容易在多台服务器之间共享，所以这也限制了 Session 的使用。</strong></p>
<pre>Cookie原理解释</pre>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;Cookie是在RFC2109（已废弃，被RFC2965取代）里初次被描述的，每个客户端最多保持三百个cookie，每个域名下最多20个Cookie（实际上一般浏览器现在都比这个多，如Firefox是50个），而每个cookie的大小为最多4K，不过不同的浏览器都有各自的实现。
&nbsp;&nbsp;&nbsp;&nbsp;对于cookie的使用，最重要的就是要控制cookie的大小，不要放入无用的信息，也不要放入过多信息。无论使用何种服务端技术.
&nbsp;&nbsp;&nbsp;&nbsp;只要发送回的HTTP响应中包含如下形式的头，则视为服务器要求设置一个cookie：
&nbsp;&nbsp;&nbsp;&nbsp;Set-cookie:name=name;expires=date;path=path;domain=domain.
&nbsp;&nbsp;&nbsp;&nbsp;支持cookie的浏览器都会对此作出反应，即创建cookie文件并保存（也可能是内存cookie），用户以后在每次发出请求时，浏览器都要判断当前所有的cookie中有没有没失效（根据expires属性判断）并且匹配了path属性的cookie信息，如果有的话，会以下面的形式加入到请求头中发回服务端：
&nbsp;&nbsp;&nbsp;&nbsp;Cookie:&nbsp;name=&quot;zj&quot;;&nbsp;Path=&quot;/linkage&quot;
&nbsp;&nbsp;&nbsp;&nbsp;服务端的动态脚本会对其进行分析，并做出相应的处理，当然也可以选择直接忽略。
&nbsp;&nbsp;&nbsp;&nbsp;这里牵扯到一个规范（或协议）与实现的问题，简单来讲就是规范规定了做成什么样子，那么实现就必须依据规范来做，这样才能互相兼容，但是各个实现所使用的方式却不受约束，也可以在实现了规范的基础上超出规范，这就称之为扩展了。
无论哪种浏览器，只要想提供cookie的功能，那就必须依照相应的RFC规范来实现。所以这里服务器只管发Set-cookie头域，这也是HTTP协议无状态性的一种体现。需要注意的是，出于安全性的考虑，cookie可以被浏览器禁用。</pre>
<pre>本地存储Cookie格式:</pre>
<pre>Cookie的特性：
	name
	value
	path
	maxAge
	domain
	version
	comment
&nbsp;&nbsp;&nbsp;&nbsp;浏览器是不是要把这个Cookie发送给服务器，是谁说的算？
&nbsp;&nbsp;&nbsp;&nbsp;浏览器决定要不要给,浏览器怎么决定?(重点,注意..)
&nbsp;&nbsp;&nbsp;&nbsp;domain+path+name来进行决定</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNC8wNzEwLzIyMzI0OV9YT1hlXzE0Mjc1NjAucG5n.jpg" /></p>
<pre>Session原理解释</pre>
<pre>&nbsp;&nbsp;&nbsp;没有找到相关的RFC，因为session本就不是协议层面的事物。它的基本原理是服务端为每一个session维护一份会话信息数据，而客户端和服务端依靠一个全局唯一的标识来访问会话信息数据。用户访问web应用时，服务端程序决定何时创建
session，创建session可以概括为三个步骤：
&nbsp;&nbsp;&nbsp;1.生成全局唯一标识符（sessionid）；
&nbsp;&nbsp;&nbsp;2.开辟数据存储空间。一般会在内存中创建相应的数据结构，但这种情况下，系统一旦掉电，所有的会话数据就会丢失，如果是电子商务网站，这种事故会造成严重的后果。不过也可以写到文件里甚至存储在数据库中，这样虽然会增加I/O开销，但session可以实现某种程度的持久化，而且更有利于session的共享；
&nbsp;&nbsp;&nbsp;3.将session的全局唯一标示符发送给客户端。
&nbsp;&nbsp;&nbsp;问题的关键就在服务端如何发送这个session的唯一标识上。联系到HTTP协议，数据无非可以放到请求行、头域或Body里，基于此，一般来说会有两种常用的方式：cookie和URL重写。
&nbsp;&nbsp;&nbsp;&nbsp;1.Cookie
&nbsp;&nbsp;&nbsp;&nbsp;读者应该想到了，对，服务端只要设置Set-cookie头就可以将session的标识符传送到客户端，而客户端此后的每一次请求都会带上这个标识符，由于cookie可以设置失效时间，所以一般包含session信息的cookie会设置失效时间为0，即浏览器进程有效时间。至于浏览器怎么处理这个0，每个浏览器都有自己的方案，但差别都不会太大（一般体现在新建浏览器窗口的时候）；
&nbsp;&nbsp;&nbsp;&nbsp;2.URL重写
&nbsp;&nbsp;&nbsp;&nbsp;所谓URL重写，顾名思义就是重写URL。试想，在返回用户请求的页面之前，将页面内所有的URL后面全部以get参数的方式加上session标识符（或者加在path&nbsp;info部分等等），这样用户在收到响应之后，无论点击哪个链接或提交表单，都会在再带上session的标识符，从而就实现了会话的保持。读者可能会觉得这种做法比较麻烦，确实是这样，但是，如果客户端禁用了cookie的话，URL重写将会是首选。
&nbsp;&nbsp;&nbsp;&nbsp;3.基于&nbsp;SSL，默认不支持，只有&nbsp;connector.getAttribute(&quot;SSLEnabled&quot;)&nbsp;为&nbsp;TRUE&nbsp;时才支持
&nbsp;&nbsp;&nbsp;&nbsp;到这里，读者应该明白我前面为什么说session也算作是对HTTP的一种扩展了吧。
&nbsp;&nbsp;&nbsp;&nbsp;如下两幅图是笔者在Firefox的Firebug插件中的截图，可以看到，当我第一次访问index.jsp时，响应头里包含了
&nbsp;&nbsp;&nbsp;&nbsp;Set-cookie头，而请求头中没有。当我再次刷新页面时，图二显示在响应中不在有Set-cookie头，而在请求头中却有了Cookie头。注意一下Cookie的名字：jsessionid，顾名思义，就是session的标识符，另外可以看到两幅图中的jsessionid的值是相同的，原因笔者就不再多解释了。如果你在web.xml&nbsp;中配置&nbsp;session-config&nbsp;配置项的话，其
&nbsp;&nbsp;&nbsp;&nbsp;cookie-config&nbsp;下的&nbsp;name&nbsp;属性就是这个SessionCookieName&nbsp;值，如果你没有配置&nbsp;session-config&nbsp;配置项，默认的&nbsp;SessionCookieName&nbsp;就是大家熟悉的“JSESSIONID”。
&nbsp;&nbsp;&nbsp;&nbsp;另外读者可能在一些网站上见过在最后附加了一段形如jsessionid=xxx的URL，这就是采用URL重写来实现的session
&nbsp;&nbsp;&nbsp;&nbsp;如果是第三种情况的话将会根据&nbsp;javax.servlet.request.ssl_session&nbsp;属性值设置&nbsp;Session&nbsp;ID.</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNC8wNzEwLzIyNDE1M19ud1ZLXzE0Mjc1NjAucG5n.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNC8wNzEwLzIyNDg0Ml83bnRwXzE0Mjc1NjAucG5n.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNC8wNzEwLzIzMDMzN19jS1VMXzE0Mjc1NjAucG5n.jpg" /></p>
<h2><strong>4.Cookie 和 Session应用场景</strong></h2>
<p><strong>&nbsp; &nbsp; &nbsp;Cookie和session由于实现手段不同，因此也各有优缺点和各自的应用场景：</strong></p>
<pre>1.应用场景
&nbsp;&nbsp;&nbsp;&nbsp;Cookie的典型应用场景是Remember&nbsp;Me服务，即用户的账户信息通过cookie的形式保存在客户端，当用户再次请求匹配的URL的时候，账户信息会被传送到服务端，交由相应的程序完成自动登录等功能。当然也可以保存一些客户端信息，比如页面布局以及搜索历史等等。
&nbsp;&nbsp;&nbsp;&nbsp;Session的典型应用场景是用户登录某网站之后，将其登录信息放入session，在以后的每次请求中查询相应的登录信息以确保该用户合法。当然还是有购物车等等经典场景；
2.安全性
&nbsp;&nbsp;&nbsp;&nbsp;cookie将信息保存在客户端，如果不进行加密的话，无疑会暴露一些隐私信息，安全性很差，一般情况下敏感信息是经过加密后存储在cookie中，但很容易就会被窃取。而session只会将信息存储在服务端，如果存储在文件或数据库中，也有被窃取的可能，只是可能性比cookie小了太多。
&nbsp;&nbsp;&nbsp;&nbsp;Session安全性方面比较突出的是存在会话劫持的问题，这是一种安全威胁，这在下文会进行更详细的说明。总体来讲，session的安全性要高于cookie；
3.性能
&nbsp;&nbsp;&nbsp;&nbsp;Cookie存储在客户端，消耗的是客户端的I/O和内存，而session存储在服务端，消耗的是服务端的资源。但是session对服务器造成的压力比较集中，而cookie很好地分散了资源消耗，就这点来说，cookie是要优于session的；
4.时效性
&nbsp;&nbsp;&nbsp;&nbsp;Cookie可以通过设置有效期使其较长时间内存在于客户端，而session一般只有比较短的有效期（用户主动销毁session或关闭浏览器后引发超时）；
5.其他
&nbsp;&nbsp;&nbsp;&nbsp;Cookie的处理在开发中没有session方便。而且cookie在客户端是有数量和大小的限制的，而session的大小却只以硬件为限制，能存储的数据无疑大了太多。</pre>
<h2>5.Cookie使用在Servlet规范</h2>
<p>在Servlet API定义Cookie相关接口.其中包括如何创建Cookie,销毁Cookie等.</p>
<pre>1.添加一个Cookie到客户端
&nbsp;&nbsp;Cookie&nbsp;cookie&nbsp;=&nbsp;new&nbsp;Cookie(&quot;LASTTIME&quot;,&nbsp;&quot;&quot;);
&nbsp;&nbsp;cookie.setMaxAge(Integer.MAX_VALUE);
&nbsp;&nbsp;cookie.setPath(request.getContextPath());
&nbsp;&nbsp;response.addCookie(cookie);</pre>
<pre>2.获取客户端的所有Cookies
&nbsp;&nbsp;Cookie&nbsp;cookies[]&nbsp;=&nbsp;request.getCookies();</pre>
<pre>3.获取自己想要的Cookie
&nbsp;&nbsp;if(cookies!=null){
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;for(int&nbsp;i=0;i&lt;cookies.length;i++){
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Cookie&nbsp;cookie&nbsp;=&nbsp;cookies[i];
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(&quot;${name}&quot;.equal(cookie.getName())){
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//to&nbsp;do&nbsp;something
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;}
&nbsp;&nbsp;//ps:实际上实现Cookie对象应该是一个Map集合.</pre>
<pre>4.将浏览器Cookie销毁
&nbsp;&nbsp;Cookie&nbsp;cookie&nbsp;=&nbsp;new&nbsp;Cookie(&quot;LASTTIME&quot;,&nbsp;&quot;&quot;);
&nbsp;&nbsp;cookie.setMaxAge(0);&nbsp;&nbsp;//将最大设置为零
&nbsp;&nbsp;cookie.setPath(request.getContextPath());
&nbsp;&nbsp;response.addCookie(cookie);</pre>
<h2>6.Session使用在Servlet/JSP规范</h2>
<pre>通过上述的讲解，读者应该对session有了一个大体的认识，但是具体到某种动态页面技术，又是怎么实现session的呢？
下面笔者将结合session的生命周期（lifecycle），从源代码的层次来具体分析一下在servlet/jsp技术中，session是怎么实现的。代码部分以tomcat6.0.20作为参考。</pre>
<ul>
<li>
<h3><strong>6.1 创建</strong></h3>
</li>
</ul>
<pre>在我问过的一些从事java&nbsp;web开发的人中，对于session的创建时机大都这么回答：当我请求某个页面的时候，session就被创建了。这句话其实很含糊，因为要创建session请求的发送是必不可少的，但是无论何种请求都会创建session吗？错。我们来看一个例子。
众所周知，jsp技术是servlet技术的反转，在开发阶段，我们看到的是jsp页面，但真正到运行时阶段，jsp页面是会被“翻译”为servlet类来执行的，例如我们有如下jsp页面：</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNC8wNzEwLzIzMjIxMl9DQXc0XzE0Mjc1NjAucG5n.jpg" /></p>
<pre>&nbsp;在我们初次请求该页面后，在对应的work目录可以找到该页面对应的java类，考虑到篇幅的原因，在此只摘录比较重要的一部分，有兴趣的读者可以亲自试一下：</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNC8wNzEwLzIzMjMzN18xZzNGXzE0Mjc1NjAucG5n.jpg" /></p>
<pre>可以看到有一句显式创建session的语句，它是怎么来的呢？我们再看一下对应的jsp页面，在jsp的page指令中加入了session=&quot;true&quot;，意思是在该页面启用session，其实作为动态技术，这个参数是默认为true的，这很合理，在此显示写出来只是做一下强调。很显然二者有着必然的联系。笔者在jsp/servlet的翻译器（org.apache.jasper.compiler）的源码中找到了相关证据：</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNC8wNzEwLzIzMjQyN18wZEwwXzE0Mjc1NjAucG5n.jpg" /></p>
<pre>这里我将其中的大致流程叙述一下：
1.用户请求某jsp页面，该页面设置了session=&quot;true&quot;；
2.Servlet/jsp容器将其翻译为servlet，并加载、执行该servlet；
3.Servlet/jsp容器在封装HttpServletRequest对象时根据cookie或者url中是否存在jsessionid来决定是绑定当前的session到HttpRequest还是创建新的session对象（在请求解析阶段发现并记录jsessionid，在Request对象创建阶段将session绑定）；
4.程序按需操作session，存取数据；
5.如果是新创建的session，在结果响应时，容器会加入Set-cookie头，以提醒浏览器要保持该会话（或者采用URL重写方式将新的链接呈现给用户）。
&nbsp;&nbsp;&nbsp;&nbsp;通过上面的叙述读者应该了解了session是何时创建的，这里再从servlet这个层面总结一下：当用户请求的servlet调用了getSession方法时，都会获取session，至于是否创建新的session取决于当前request是否已绑定session。当客户端在请求中加入了jsessionid标识而servlet容器根据此标识查找到了对应的session对象时，会将此session绑定到此次请求的request对象，客户端请求中不带jsessionid或者此jsessionid对应的session已过期失效时，session的绑定无法完成，此时必须创建新的session。同时发送Set-cookie头通知客户端开始保持新的会话。</pre>
<ul>
<li>
<h3><strong>6.2 保持</strong></h3>
</li>
</ul>
<pre>理解了session的创建，就很好理解会话是如何在客户端和服务端之间保持的了。当首次创建了session后，客户端会在后续的请求中将session的标识符带到服务端，服务端程序只要在需要session的时候调用getSession，服务端就可以将对应的session绑定到当前请求，从而实现状态的保持。当然这需要客户端的支持，如果禁用了cookie而又不采用url重写的话，
session是无法保持的。
&nbsp;&nbsp;&nbsp;&nbsp;如果几次请求之间有一个servlet未调用getSession（或者干脆请求一个静态页面）会不会使得会话中断呢？这个不会发生的，因为客户端只会将合法的cookie值传送给服务端，至于服务端拿cookie做什么事它是不会关心的，当然也无法关心。Session建立之后，客户端会一直将session的标识符传送到服务器，无论请求的页面是动态的、静态的，甚至是一副图片</pre>
<ul>
<li>
<h3><strong>6.3 销毁</strong></h3>
</li>
</ul>
<pre>此处谈到的销毁是指会话的废弃，至于存储会话信息的数据结构是回收被重用还是直接释放内存我们并不关心。Session的销毁有两种情况：超时和手动销毁。
&nbsp;&nbsp;&nbsp;&nbsp;由于HTTP协议的无状态性，服务端无法得知一个session对象何时将再次被使用，可能用户开启了一个session之后再也没有后续的访问，而且session的保持是需要消耗一定的服务端开销的，因此不可能一味地创建session而不去回收无用的session。这里就引入了一个超时机制。Tomcat中的超时在web.xml里做如下配置：</pre>
<p><strong></strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNC8wNzEwLzIzMjkxOF9qM3l4XzE0Mjc1NjAucG5n.jpg" /></p>
<pre>上述配置是指session在30分钟没有被再次使用就将其销毁。Tomcat是怎么计算这个30分钟的呢？原来在getSession之后，都要调用它的access方法，修改lastAccessedTime，在销毁session的时候就是判断当前时间和这个lastAccessedTime的差值。
&nbsp;&nbsp;&nbsp;&nbsp;手动销毁是指直接调用其invalidate方法，此方法实际上是调用expire方法来手动将其设置为超时。
&nbsp;&nbsp;&nbsp;&nbsp;当用户手动请求了session的销毁时，客户端是无法知道服务端的session已经被销毁的，它依然会发送先前的session标识符到服务端。而此时如果再次请求了某个调用了getSession的servlet，服务端是无法根据先前的session标识符找到相应的session对象的，这是又要重新创建新的session，分配新的标识符，并告知服务端更新session标识符开始保持新的会话。</pre>
<ul>
<li>
<h3><strong>6.4 生命周期</strong></h3>
<p>Session生命周期如图所示:</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNC8wNzEwLzIzMzIwOV9KOFJQXzE0Mjc1NjAuanBn.jpg" /></p>
<ul>
<li>
<h3><strong>6.5 Session的数据结构</strong></h3>
</li>
</ul>
<p><strong>&nbsp; &nbsp; &nbsp;首先让我们看一看Session相关类图.<br /></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNC8wNzEwLzIzMzU0M19CbGZJXzE0Mjc1NjAuanBn.jpg" /></strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;上从图中可以看出从&nbsp;request.getSession&nbsp;中获取的&nbsp;HttpSession&nbsp;对象实际上是&nbsp;StandardSession&nbsp;对象的门面对象，这与前面的Request和Servlet&nbsp;是一样的原理.</pre>
<p>在servlet/jsp中，容器是用何种数据结构来存储session相关的变量的呢？我们猜测一下，首先它必须被同步操作，因为在多线程环境下session是线程间共享的，而web服务器一般情况下都是多线程的（为了提高性能还会用到池技术）；其次，这个数据结构必须容易操作，最好是传统的键值对的存取方式。</p>
<p>那么我们先具体到单个session对象，它除了存储自身的相关信息，比如id之外，tomcat的session还提供给程序员一个用以存储其他信息的接口（在类org.apache.catalina.session. StandardSession里）：</p>
<pre>public&nbsp;void&nbsp;setAttribute(String&nbsp;name,&nbsp;Object&nbsp;value,&nbsp;boolean&nbsp;notify);</pre>
<p>在这里可以追踪到它到底使用了何种数据：</p>
<pre>protected&nbsp;Map&nbsp;attributes&nbsp;=&nbsp;new&nbsp;ConcurrentHashMap();</pre>
<p>这就很明确了，原来tomcat使用了一个ConcurrentHashMap对象存储数据，这是java的concurrent包里的一个类。它刚好满足了我们所猜测的两点需求：同步与易操作性。</p>
<p>那么tomcat又是用什么数据结构来存储所有的session对象呢？果然还是ConcurrentHashMap（在管理session的org.apache.catalina.session. ManagerBase类里）：</p>
<pre>protected&nbsp;Map&lt;String,&nbsp;Session&gt;&nbsp;sessions&nbsp;=&nbsp;new&nbsp;ConcurrentHashMap&lt;String,&nbsp;Session&gt;();</pre>
<p>具体原因就不必多说了。至于其他web服务器的具体实现也应该考虑到这两点。</p>
<h2>7.关于Session Hijack</h2>
<p>详情见下列的参考博客..</p>
<h2>8.关于Session的钝化和激活.</h2>
<pre>要实现Session钝化持久化到硬盘,就必须存储在Session中对象的类实现java.io.Serializable接口.</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNC8wNzExLzIxMTQzM19jZGl6XzE0Mjc1NjAucG5n.jpg" /></p>
<p>结束。。。。。。。。。。。。。。。。。。。。。。。</p>
<p><strong>参考博客:</strong></p>
<p><strong><a href="http://www.ibm.com/developerworks/cn/java/j-lo-servlet/" rel="external nofollow noreferrer">http://www.ibm.com/developerworks/cn/java/j-lo-servlet/</a></strong></p>
<p><strong><a href="http://www.cnblogs.com/shoru/archive/2010/02/19/1669395.html" rel="external nofollow noreferrer">http://www.cnblogs.com/shoru/archive/2010/02/19/1669395.html</a></strong></p>
<p><strong>参考Servlet API:</strong></p>
<p><strong><a href="http://docs.oracle.com/cd/E17802_01/products/products/servlet/2.5/docs/servlet-2_5-mr2/" rel="external nofollow noreferrer">http://docs.oracle.com/cd/E17802_01/products/products/servlet/2.5/docs/servlet-2_5-mr2/</a> </strong></p>
<p><P>2014-07-09 Java Web的学习(5)-----会话管理(Cookie和Session)</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 06:31:47 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>2014-07-09 Java Web的学习(5)-----会话管理(Cookie和Session)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r9YYw0.html" rel="bookmark">web安全学习-攻击会话管理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先来说一下什么是会话管理?在绝大多数web应用程序中,会话管理机制是一个基本的安全组件.它帮助应用程序从大量不同的请求中确认特定的用户,并处理它收集的关于用户与应用程序交互状态的数据.会话管理在应用程序执行登陆功能时显得特别重要,因为它可在用户通过请求提交他们的证书后,持续向应用程序保证任何用户身份的真实性. 由于会话管理机制所发挥的关键作用,它们成为针对应用程序的恶意攻击的主要目标.如果攻击者能够破坏应用程序的会话管理,他就能轻易避开其实施的验证机制,不需要用户证书即可伪装成其他应用程序用户.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ejLlD3.html" rel="bookmark">express学习（三）&mdash;&mdash; cookie和session</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				express学习(三)-- cookie和session cookie存在浏览器中,最大只能保存4K数据,不安全 session存在服务器中,不能独立(先读取cookie再读取session),较安全 cookie 工具 发送cookie: 基本的东西先写好: const express = require('express'); var server=express(); // cookie server.use('/',function(req,res){ res.cookie('名字',			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35axeo3.html" rel="bookmark">Java Web入门学习路线图的规划</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java作为学习编程开发入门语言,可能对于许多新手来说可能有点摸不着北,做位一名有几年开发经验的老鸟,希望给一些新人分享经验,当然其他老鸟如果有什么意见可以指出,我也会努力纠正. 本人工作是有关Java Web 开发,所以我会以Java Web标准开发去做一个标准,当然Java 能做的事情很多,包括Android,Java Me等,后期只要我们努力可以学习更多,更深的我也说不了,我现在只谈谈怎么去入门,至于登堂入室,大家有了套路以后,都能够达到.我写这个初衷,是因为我本来是一名非计算机专业的学生			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49roNgM.html" rel="bookmark">java web filter 学习（2）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要对filter的基本使用进行了讲解,其中涉及到了 filter是什么 一个filter处理一个jsp 多个filter处理一个jsp filter是什么 Filter 是java下的一种过滤器 ,能实现对java web程序 客户端和服务器端消息的过滤,也就是在服务器段接受request之前,可以预先对request进行处理,或在客户端接受response之前,对response进行处理. Filter的使用非常灵活,是在&quot;链&quot;到客户端和服务器之间的,在需要时可以配置到客户端与			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPY98z0.html" rel="bookmark">Java web 会话技术 cookie与session</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.会话 会话可简单理解为:用户开一个浏览器,点击多个超链接,访问服务器多个web资源,然后关闭浏览器,整个过程称之为一个会话. 会话过程中要解决的一些问题 每个用户在使用浏览器与服务器进行会话的过程中,不可避免各自会产生一些数据,程序要想办法为每个用户保存这些数据. 二.保存会话数据的两种技术 1.Cookie Cookie是客户端技术,程序把每个用户的数据以cookie的形式写给用户各自的浏览器.当用户使用浏览器再去访问服务器中的web资源时,就会带着各自的数据去.这样,web资源处理的就是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xowknM.html" rel="bookmark">Servlet学习&lpar;七&rpar;&mdash;&mdash;会话技术cookie&amp;amp&semi;session</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.会话技术简介 1．存储客户端的状态 例如网站的购物系统,用户将购买的商品信息存储到哪里?因为Http协议是无状态的,也就是说每个客户访问服务器端资源时,服务器并不知道该客户端是谁,所以需要会话技术识别客户端的状态.会话技术是帮助服务器记住客户端状态(或者说区分客户端,是张三登录的还是李四登录的) 2．会话技术 从打开一个浏览器访问某个站点,到关闭这个浏览器的整个过程,成为一次会话.会话技术就是记录这次会话中客户端的状态与数据的. 会话技术分为Cookie和Session: Cookie:数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dk7drM.html" rel="bookmark">JAVA基础之会话技术-Cookie及Session</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				至此,学习三个域对象:ServletContext(web项目).request(一次请求).Session(一个客户端)!均有相同的方法! 从用户开始打开浏览器进行操作,便开始了一次会话,直至关闭浏览器为止结束.在此过程中,每次产生请求时均会产生一次cookie,同时会产生一个JESSIONID进入到客户端进行创建内存空间,下次调用直接寻找此唯一的ID值.数据存储在两个地方均有利弊!需要注意的是,浏览器关闭,session并没有销毁! 一.会话技术简介: 1.存储客户端的状态: 因为Http协			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/V02kbR3.html" rel="bookmark">学习日常笔记&amp;lt&semi;day11&amp;gt&semi;cookie及session</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.会话管理 1.1会话管理定义 会话管理:管理浏览器客户端和服务端之间的会话过程中产生的会话数据 域对象:实现资源之间的数据共享 request 域对象 context 域对象 1.2.会话技术 Cookie技术:会话数据保存在浏览器客户端中 Session技术:会话数据保存在服务器端 2.Cookie技术 2.1 特点 Session技术:会话数据保存在服务器端 2.2Cookie技术核心 Cookie类:用于存储会话数据 1)构造Cookie对象 Cookie(java.lang.Stri			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLxAlyM.html" rel="bookmark">Web安全开发指南--会话管理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.会话管理 3.1.会话管理安全规则 1 避免在URL携带session id. 2 使用SSL加密通道来传输cookie. 3 避免在错误信息和调试日志中记录session id. 4 使用框架自带的或业界公认的安全函数来生成session id(参考附录11.4). 5 开发或引入无状态的模块(比如shipin7 nodejs和视频留言模块)时,应与web模块的session机制结合,防止越权或无授权攻击. 6 当使用加密通道SSL/TLS传输cookie时,为其设置“secure”属性.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JkYAVM.html" rel="bookmark" class="title">7&period;3 数组递推</a>
					<div>
						1 #include&lt;stdio.h&gt; 2 int main() 3 { 4 int a[20]; 5 int i; 6 a[0]=1;a[1]=1;a[2]=2; 7 printf(&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MB1qqA4.html" rel="bookmark" class="title">JSON资料整理</a>
					<div>
						  目录 1.什么是json 2.json语法规则 3.json基础结构 4.json基础示例 5.JSON和XML比较 6. .NET操作JSON 原始方式 通用方式 内置方式 契约方式 通过序列化 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vKnwR4.html" rel="bookmark" class="title">数据可视化之MarkPoint</a>
					<div>
						MarkPoint是什么效果?如上图,一闪一闪亮晶晶的效果,这是在Echarts中对应的效果.我最早看到的是腾讯的一个Flash的版本,显示当前QQ在线人数的全国分布效果,感觉效果很炫,当时也在想,怎 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NGy28M.html" rel="bookmark" class="title">HDU 1394 Minimum Inversion Number（线段树求逆序数）</a>
					<div>
						题目地址:HDU 1394 这题可以用线段树来求逆序数. 这题的维护信息为每个数是否已经出现.每次输入后,都从该点的值到n-1进行查询,每次发现出现了一个数,由于是从该数的后面开始找的,这个数肯定是比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02kYa23.html" rel="bookmark" class="title">设置MySQL允许外网访问</a>
					<div>
						1.修改配置文件sudo vim /etc/mysql/my.cnf把bind-address参数的值改成你的内/外网IP或0.0.0.0,或者直接注释掉这行. 2.登录数据库mysql -u roo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLPOdeM.html" rel="bookmark" class="title">linux-redhat6&period;4驱动无线网卡rtl8188eu</a>
					<div>
						无线网卡Realtek Semiconductor Cop. RTL8188EUS  首先下载安装包: ?其中的0BDA是Realtek的代码,8179是设备代码.从网上查到这个设备的芯片是rtl81 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a1wxv0.html" rel="bookmark" class="title">囫囵吞枣&mdash;JavaScript</a>
					<div>
						丢~本想复习HTML的,可是就是那么没耐心,转去看HTML5.才发现居然要涉及JavaScript知识,好吧,辗转先学习JavaScript. 我对JavaScript或许连皮毛都不懂,一路上估计又是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49LrzA3.html" rel="bookmark" class="title">优化iptables</a>
					<div>
						永久关闭iptables: 1.先查看iptables状态 /etc/init.d/iptable sstatus 2.临时关闭iptables /etc/init.d/iptables stop 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pL8Zx4.html" rel="bookmark" class="title">Extensible Access Control List Framework</a>
					<div>
						Methods, systems, and products for governing access to objects on a filesystem. In one general embod ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NnLj64.html" rel="bookmark" class="title">1  ERP管理系统概念</a>
					<div>
						1 ERP管理系统概念 一.ERP是什么? ERP是企业资源计划(Enterpise Resource Planning)的简称,蕴含现代企业管理理念,其核心是在制造资源计划基础上进一步发展而成的面向 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVqaqw4.html" rel="bookmark" class="title">nginx 知识</a>
					<div>
						nginx如何实现高并发? 启动nginx服务器后,输入 ps -ef |grep nginx,会发现nginx有一个master进程 和若干个worker进程, 这些worker进程是平等的,都是被 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6lYnv3.html" rel="bookmark" class="title">mybat-大文件的存取</a>
					<div>
						在mybatis中存储大文件可以直接存 取的时候取出来的是二进制 1.在实体类中添加大文本和图片 package com.java1234.model; public class Student {  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MobnYx4.html" rel="bookmark" class="title">sql优化笔记</a>
					<div>
						count(primarykey)和count(*)那个更快 在ADO.Net里使用ExecuteScalar使用count(primarykey)比count(*)快很多.但是在PL/SQL里直接执 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kNJ1EM.html" rel="bookmark" class="title">actionbar修改背景颜色</a>
					<div>
						http://www.aichengxu.com/view/6015 本来是想着自定义标题栏,发现老是出错.貌似4.0以上版本都不能自定义标题栏(我到现在都搞不清标题栏和actionBar的区别到底是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MynBXA0.html" rel="bookmark" class="title">windows时间同步命令</a>
					<div>
						在域环境中,经常遇到服务器与域控时间不同步的时,会导致用户访问应用出错,如果遇到可以执行强制同步命令 w32tm /resync /computer:hostname					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xAg6L3.html" rel="bookmark" class="title">zoj 2081 BFS 延迟标记 读入问题</a>
					<div>
						Mission Impossible Time Limit: 2 Seconds                                     Memory Limit: 65536 KB  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xAOwk3.html" rel="bookmark" class="title">C&plus;&plus;面向对象高级编程&lpar;六&rpar;转换函数与non-explicit one argument ctor</a>
					<div>
						技术在于交流.沟通,转载请注明出处并保持作品的完整性. 1.conversion function 转换函数 //1.转换函数 //conversion function //只要你认为合理 你可以任 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXDkLwM.html" rel="bookmark" class="title">《UNIX网络编程》 -- 第五章</a>
					<div>
						str_cli 和 str_echo 函数 需要先弄清楚 3.9 readn.writen 和 readline 函数 str_cli void str_cli(FILE *fp, int sockf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pGNAJ3.html" rel="bookmark" class="title">uva 11212</a>
					<div>
						由于编辑的特殊性,只要没达到升序这个条件就可以永远不停的搜下去,最特别的还是那些的错误的路径,也就是说假如一开始就选择了错误的剪切方式,之后这条错误的路会一直往后延伸... 所以采用IDA*解法,ID ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OQwXKM.html" rel="bookmark" class="title">将android客户端的错误日志压缩上传到服务器</a>
					<div>
						原文:将android客户端的错误日志压缩上传到服务器 源代码下载地址:http://www.zuidaima.com/share/1550463760370688.htm					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
